--[[
		    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


                              ####    ######        ####     #######      ####    #######    #         ########
                             ##  ##   #     ##    ##    ##   #     ##    ##  ##   #     ##   #         #
                            #      #  #      ##  ##      ##  #       #  #      #  #       #  #         #
                            #      #  #       #  #        #  #     ##   #      #  #     ##   #         #
                            ########  #       #  #        #  #######    ########  #######    #         ########
                            #      #  #       #  #        #  #   #      #      #  #     ##   #         #
                            #      #  #      ##  ##      ##  #    #     #      #  #       #  #         #
                            #      #  #     ##    ##    ##   #     #    #      #  #     ##   #         #
                            #      #  ######        ####     #      #   #      #  #######    ########  ########


                          #      #    ####    #########     ######    #      #  #         #  #       #     ####  
                          #      #   ##  ##       #       ##      ##  #      #  #         #  ##      #   ##    ##
                          #      #  #      #      #      ##           #      #  #         #  # #     #  ##
                          #      #  #      #      #      #            #      #  #         #  #  #    #  #
                          ########  ########      #      #            ########  #         #  #   #   #  #
                          #      #  #      #      #      #            #      #  #         #  #    #  #  #     ###
                          #      #  #      #      #      ##           #      #  #         #  #     # #  ##      #
                          #      #  #      #      #       ##      ##  #      #  #         #  #      ##   ##    ##
                          #      #  #      #      #         ######    #      #  ########  #  #       #     ####  


                                            #       #  ########    ####    #########    ####  
                                            ##      #  #         ##    ##      #      ##    ##
                                            # #     #  #         #             #      #
                                            #  #    #  #         ##            #      ##
                                            #   #   #  ########   ######       #       ######
                                            #    #  #  #               ##      #            ##
                                            #     # #  #                 #     #              #
                                            #      ##  #         ##    ##      #      ##    ##
                                            #       #  ########    ####        #        ####  


                                                       --==  BATTLE FOR AZEROTH  ==--
													   

                    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


                                                    ----o----(||)----oo----(||)----o----

                                                            v4.02 4th July 2019
                                                    Copyright (C) Taraezor / Chris Birch

                                                    ----o----(||)----oo----(||)----o----
													
													
]]

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Localisations and Local Data
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local addonName, L = ...
local addonTitle = addonName

local cos = math.cos
local date = date
local find = string.find
local format = string.format
local gmatch = string.gmatch
local gsub = string.gsub
local lower = string.lower
local random = random
local sin = math.sin
local sqrt = math.sqrt
local sub = string.sub
local tonumber = tonumber
local tostring = tostring

local CreateFrame = CreateFrame
local EnumerateFrames = EnumerateFrames
local GameTooltip = GameTooltip
local GetBestMapForUnit = C_Map.GetBestMapForUnit
local GetCursorPosition = GetCursorPosition
local GetCVar = GetCVar
local GetItemInfo = GetItemInfo
local GetPlayerFacing = GetPlayerFacing
local GetPlayerMapPosition = C_Map.GetPlayerMapPosition
local GetSubZoneText = GetSubZoneText
local GetTime = GetTime
local IsControlKeyDown = IsControlKeyDown
local IsIndoors = IsIndoors
local IsShiftKeyDown = IsShiftKeyDown
local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton
local UIDropDownMenu_AddSeparator = UIDropDownMenu_AddSeparator
local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo
local UIDropDownMenu_InitializeHelper = UIDropDownMenu_InitializeHelper
local WorldMapTooltip = WorldMapTooltip

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Local Functions
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function PlayRandomSound()

	if ( AdorableHatchlingNestsDB.raptorSounds == "n" ) then return end
	
	local randomNum = 0
	local month = tonumber( date( "%m" ) )
	local today = tonumber( date( "%d" ) )

	if ( today % 2 == 0 ) then
		if ( ( month == 4 ) and ( today == 1 ) ) or ( AdorableHatchlingNestsDB.alwaysAprilFool == "y" ) then
			if ( random( 10 ) >= 8 ) then
				PlaySoundFile( "Interface\\AddOns\\AdorableHatchlingNests\\Godzilla.mp3" )
			else
				PlaySound(18178)
			end
		else
			PlaySound( 18178 )
		end
	else
		if ( ( month == 4 ) and ( today == 1 ) ) or ( AdorableHatchlingNestsDB.alwaysAprilFool == "y" ) then
			randomNum = random( 20 )
			PlaySoundFile(	( ( randomNum >= 10 ) and "Interface\\AddOns\\AdorableHatchlingNests\\Godzilla.mp3" ) or
					( ( randomNum >= 7 ) and "Interface\\AddOns\\AdorableHatchlingNests\\TyrannosaurusRex1.mp3" ) or
					( ( randomNum >= 4 ) and "Interface\\AddOns\\AdorableHatchlingNests\\Velociraptor1.mp3" ) or
					( "Interface\\AddOns\\AdorableHatchlingNests\\Velociraptor2.mp3" ) )
		else
			randomNum = random( 20 )
			PlaySoundFile(	( ( randomNum >= 15 ) and "Interface\\AddOns\\AdorableHatchlingNests\\TyrannosaurusRex1.mp3" ) or
					( ( randomNum >= 8 ) and "Interface\\AddOns\\AdorableHatchlingNests\\Velociraptor1.mp3" ) or
					( "Interface\\AddOns\\AdorableHatchlingNests\\Velociraptor2.mp3" ) )
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Colour Printing - Purple Theme
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local pc_colour_Prefix		= "\124cFF8258FA"
local pc_colour_Highlight	= "\124cFFB19EFF"
local pc_colour_PlainText	= "\124cFF819FF7"

local function printPC( message )
	if message then
		DEFAULT_CHAT_FRAME:AddMessage( pc_colour_Prefix.. addonTitle.. ": ".. pc_colour_PlainText.. message.. "\124r" )
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Pin Textures
--		============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local textures = {
		E = {
			["1"] = "Interface\\TargetingFrame\\UI-PhasingIcon", ["2"] = "Interface\\Store\\Category-icon-pets",
			["3"] = "Interface\\Store\\Category-icon-featured", ["4"] = "Interface\\PlayerFrame\\MonkDarkPower",
			["5"] = "Interface\\PlayerFrame\\MonkLightPower", ["6"] = "Interface\\Common\\Friendship-ManaOrb",		
			["7"] = "Interface\\LFGFrame\\BattlenetWorking", ["8"] = "Interface\\HelpFrame\\HelpIcon-CharacterStuck",		
			["9"] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Frost", ["10"] = "Interface\\TargetingFrame\\PetBadge-Magical",	
			["11"] = "Interface\\Common\\Indicator-Red", ["12"] = "Interface\\Common\\Indicator-Yellow",
			["13"] = "Interface\\Common\\Indicator-Green", ["14"] = "Interface\\Vehicles\\UI-Vehicles-Raid-Icon",
			
			num = 14,
			
			coords = { ["1"] = { 0, 1, 0, 1}, ["2"] = { 0, 1, 0, 1}, ["3"] = { 0, 1, 0, 1}, ["4"] = { 0, 1, 0, 1}, ["5"] = { 0, 1, 0, 1}, 
					["6"] = { 0, 1, 0, 1}, ["7"] = { 0, 1, 0, 1}, ["8"] = { 0, 1, 0, 1}, ["9"] = { 0, 1, 0, 1}, ["10"] = { 0, 1, 0, 1}, 
					["11"] = { 0, 1, 0, 1}, ["12"] = { 0, 1, 0, 1}, ["13"] = { 0, 1, 0, 1}, ["14"] = { 0, 1, 0, 1}, },

			-- I should also have an X,Y offset due to scaling adjustments and a texture might not have the same origin placement
			size = { ["1"] = 0.95, ["2"] = 1.2, ["3"] = 1.2, ["4"] = 0.85, ["5"] = 0.85, ["6"] = 0.95, ["7"] = 0.9, ["8"] = 0.93, 
					["9"] = 0.62, ["10"] = 0.73, ["11"] = 0.83, ["12"] = 0.83, ["13"] = 0.83, ["14"] = 0.67, },
					
			name = { ["1"] = L["Phasing"], ["2"] = L["Raptor egg"], ["3"] = L["Stars"], ["4"] = L["Purple"], ["5"] = L["White"], 
					["6"] = L["Mana Orb"], ["7"] = L["Eye"], ["8"] = L["Cogwheel"], ["9"] = L["Frost"], ["10"] = L["Diamond"], 
					["11"] = L["Red"], ["12"] = L["Yellow"], ["13"] = L["Green"], ["14"] = L["Screw"], }, },

		S = {
			["1"] = "Interface\\Common\\RingBorder", ["2"] = "Interface\\PetBattles\\DeadPetIcon",
			["3"] = "Interface\\Glues\\CharacterSelect\\CharacterUndelete", ["4"] = "Interface\\RaidFrame\\UI-RaidFrame-Threat", 
			["5"] = "Interface\\Challenges\\Challenges-Copper", ["6"] = "Interface\\PlayerFrame\\DeathKnight-Energize-Blood", 
			["7"] = "Interface\\PlayerFrame\\DeathKnight-Energize-Frost", ["8"] = "Interface\\PlayerFrame\\DeathKnight-Energize-Unholy", 
			
			num = 8,
			
			coords = { ["1"] = { 0, 1, 0, 1}, ["2"] = { 0, 1, 0, 1}, ["3"] = { 0, 1, 0, 1}, ["4"] = { 0, 1, 0, 1}, ["5"] = { 0, 1, 0, 1}, 
					["6"] = { 0, 1, 0, 1}, ["7"] = { 0, 1, 0, 1}, ["8"] = { 0, 1, 0, 1}, },

			-- I should also have an X,Y offset due to scaling adjustments and a texture might not have the same origin placement
			size = { ["1"] = 0.58, ["2"] = 0.68, ["3"] = 1.15, ["4"] = 0.65, ["5"] = 0.65, ["6"] = 0.77, ["7"] = 0.77, ["8"] = 0.77, },
					
			name = { ["1"] = L["Gold Ring"], ["2"] = L["Red Cross"], ["3"] = L["Undo"], ["4"] = L["White Diamond"], 
					["5"] = L["Copper Diamond"], ["6"] = L["Red Ring"], ["7"] = L["Blue Ring"], ["8"] = L["Green Ring"], }, }, }

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Locations
--		=========
--
--		This is without a doubt the most comprehensively organised and annotated list of locations. And accurate to boot!
--
--------------------------------------------------------------------------------------------------------------------------------------------

local tips = {
		D = {	-- Dustwallow Marsh
			["1"] = { ["x"] = 46.50, ["y"] = 17.15, },
			["2"] = { ["x"] = 47.98, ["y"] = 19.07, },
			["3"] = { ["x"] = 48.01, ["y"] = 14.26, },
			["4"] = { ["x"] = 49.17, ["y"] = 17.36, },
			tipTitle = L[ "Dart's Nest" ],
			tipLine1 = L[ "Leaping Hatchling" ],
			eggID = 48118,
			num = 4, },
		N = {	-- Northern Barrens
			["1"] = { ["x"] = 60.95, ["y"] = 19.76, },
			["2"] = { ["x"] = 62.76, ["y"] = 20.18, },
			["3"] = { ["x"] = 64.17, ["y"] = 23.00, },
			["4"] = { ["x"] = 64.94, ["y"] = 28.60, },
			tipTitle = L[ "Takk's Nest" ],
			tipLine1 = L[ "Darting Hatchling" ],
			eggID = 48112,
			num = 4, },
		U = {	-- Un'Goro Crater
			["1"] = { ["x"] = 62.06, ["y"] = 73.36, ["tip"] = L[ "Under the foliage" ] },
			["2"] = { ["x"] = 62.09, ["y"] = 65.23, },
			["3"] = { ["x"] = 62.97, ["y"] = 63.08, ["tip"] = L[ "Under the foliage" ] },
			["4"] = { ["x"] = 68.83, ["y"] = 66.79, ["tip"] = L[ "Under the foliage" ] },
			["5"] = { ["x"] = 68.95, ["y"] = 61.06, ["tip"] = L[ "Under the foliage" ] },
			tipTitle = L[ "Ravasaur Matriarch's Nest" ],
			tipLine1 = L[ "Ravasaur Hatchling" ],
			eggID = 48122,
			num = 5, },
		S = {	-- Wetlands Special
			["1"] = { ["x"] = 69.37, ["y"] = 34.91, },
			tipTitle = L[ "Cave Entrance" ],
			tipLine1 = L[ "Raptor Ridge" ],
			eggID = 48124,
			num = 1, },
		W = {	-- Wetlands
			["1"] = { ["x"] = 70.03, ["y"] = 29.15, ["tip"] = 
													L[ "Veer to the right as you enter the cave.\nAccess the nest from the right side" ] },
			tipTitle = L[ "Razormaw Matriarch's Nest" ],
			tipLine1 = L[ "Razormaw Hatchling" ],
			eggID = 48124,
			num = 1, }
		}

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		MiniMap Setup
--		=============
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- Mini holds the textures/tooltips for the Minimap pins plus a few flags/fields used also on the World Map.
-- In particular, the blinking eye fields will be saved here (prior to 8.0.1 it was only reasonably feasible to blink on the Minimap).
-- This is sufficient to establish a large enough pool of random eyeIDs
-- wasInCorrectZone has been repurposed from a boolean to holding the zone "letter" or nil. This due to there being multiple zones
-- "S" is Wetlands Raptor Ridge cave entrance and "W" is the interior, so Wetlands effectively has two quite separate sub-zones

local mini = { 
		zoom = 0, width = 0, height = 0, xPlayer = 0, yPlayer = 0, tooltipShowing = false, insideCaveRR = false, wasInCorrectZone = nil, 
		allowBlink = true, mapAreaInID = 0, mapAreaInIDStr = "", firstTimeShowing = true, leftMouseUp = false, 
		validMapIDs = { ["10"] = "N", ["56"] = "S", ["70"] = "D", ["78"] = "U" }, 
		dustwallowMarshID = 70, northernBarrensID = 10, unGoroCraterID = 78, wetlandsID = 56,
		radii = { [0] = (233 + 1/3), [1] = 200, [2] = (166 + 2/3), [3] = (133 + 1/3), [4] = 100, [5] = (66 + 2/3) },
		scale= {
			D = { x = 0.038, y = 0.057 },
			N = { x = 0.035, y = 0.052 },
			U = { x = 0.055, y = 0.081 },
			S = { x = 0.048, y = 0.075 },
			W = { x = 0.028, y = 0.042, stepX = ( 0.028 - 0.018 ) / 5, stepY = ( 0.042 - 0.027 ) / 5 },
			},
		}
					
--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Assign Pins to the Mini Map
--		===========================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function AssignMiniMapPins()

	-- With the Minimap we create tables of textures, with the World Map we create tables of buttons and textures
						
	for k, v in pairs( tips ) do
		local t = ( k == "S" ) and "S" or "E"
		mini[ k ] = {}
		for i = 1, v.num do
			mini[ k ][ i ] = Minimap:CreateTexture( nil, "OVERLAY" )
			mini[ k ][ i ]:SetAlpha( 0 )
			mini[ k ][ i ].eyeID = random( 8 ) + 16
			mini[ k ][ i ].eyeSpeed = 0.05 * random( 6 ) + 0.1				
			local textureID = ( AdorableHatchlingNestsDB[ "saved".. k ][ tostring( i ) ] or AdorableHatchlingNestsDB[ "texture".. k ] )
			mini[ k ][ i ]:SetTexture( ( textureID == "7" ) and textures[ t ][ textureID ].. tostring( floor( mini[ k ][ i ].eyeID ) )
															or textures[ t ][ textureID ] )
			mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ textureID ] ) )
			mini[ k ][ i ]:SetSize( 0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ textureID ],
									0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ textureID ] )
			mini[ k ][ i ].tooltip = v[ tostring( i ) ].tip 
			mini[ k ][ i ].x = v[ tostring( i ) ].x
			mini[ k ][ i ].y = v[ tostring( i ) ].y
			mini[ k ][ i ].k = k
		end
	end
	
	Minimap:HookScript( "OnMouseUp", function( self, button ) if ( button == "LeftButton" ) then mini.leftMouseUp = true end end )	
	mini.firstTimeShowing = false
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Show on the Mini Map
--		====================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function AdjustMinimapCoordinates( x, y, k )

	local distX, distY, scaledX, scaledY = mini.xPlayer - x, mini.yPlayer - y

	if ( k == "W" ) then
		scaledX = distX / ( mini.radii[ mini.zoom ] * ( mini.scale[ "W" ].x - mini.scale[ "W" ].stepX * mini.zoom ) )
		scaledY = distY / ( mini.radii[ mini.zoom ] * ( mini.scale[ "W" ].y - mini.scale[ "W" ].stepY * mini.zoom ) )
	else
		scaledX = distX / ( mini.radii[ mini.zoom ] * mini.scale[ k ].x )
		scaledY = distY / ( mini.radii[ mini.zoom ] * mini.scale[ k ].y )
	end

	if ( GetCVar( "rotateMinimap" ) == "1" ) then
		local cosTheta, sinTheta = cos( GetPlayerFacing() ), sin( GetPlayerFacing() )
		scaledX, scaledY = cosTheta * scaledX - sinTheta * scaledY, sinTheta * scaledX + cosTheta * scaledY
	end

	local pointRadiusSquared = scaledX^2 + scaledY^2

	-- Allow to float on border and not exceed border, except when blinking
	mini.allowBlink = ( pointRadiusSquared < 0.17 ) and true or false
		
	if pointRadiusSquared > 0.2025 then
		local reductionRatio = 0.45 / sqrt( pointRadiusSquared )
		scaledX, scaledY = scaledX * reductionRatio, scaledY * reductionRatio
	end

	return -scaledX * mini.width, scaledY * mini.height
end

local function MinimapEyeMovements( entity, i, pinType )

	-- WoW has several "raptor eye" textures named "Interface\\LFGFrame\\BattlenetWorking"..nn
	-- When you are queued for an instance, WoW presents these textures in a cycle, resulting in a moving eye animation
	-- This AddOn also cycles through some of these textures. For variety, I vary the speed of eye movement and randomise a blinking effect
	-- Every possible pin will have an entity.eyeID (range 17 to 24) and entity.eyeSpeed (range  0.15 to 0.4)

	if ( AdorableHatchlingNestsDB[ "saved".. pinType ][ tostring( i ) ] 
						and ( AdorableHatchlingNestsDB[ "saved".. pinType ][ tostring( i ) ] ~= "7" ) ) 
						or ( AdorableHatchlingNestsDB[ "texture".. pinType ] ~= "7" ) then
		return
	end
	
	local t = ( pinType == "S" ) and "S" or "E"

	-- Will be false if too close to the Minimap border. This to prevent the annoying "fighting" amongst overlapping textures
	if ( mini.allowBlink == false ) then
		if entity.blinking then
			entity:SetTexture( textures[ t ][ "7" ].. tostring( floor( entity.eyeID ) ) )
			entity.blinking = nil
		end
		return
	end
	
	-- eyeID constantly changes. When exactly "19" blinking will randomly be triggered if not already blinking
	if floor( entity.eyeID ) == 19 then	-- blink decision at 19
		-- Is it not already blinking?
		if ( entity.blinking == nil ) then
			-- Don't blink too often as it can be quite distracting. Blink "just" often enough!
			if ( random( 60 ) >= 55 ) then		-- 10% of the time
				entity.blinking = 0				-- This holds the blinking textureID 1->2->3->4->4->3->2->1
				entity.direction = 1
			end
		end
	end
	if entity.blinking then
		-- The close and open animation is here
		entity.blinking = entity.blinking + entity.direction
		if ( entity.blinking > 4 ) then
			entity.blinking = 4
			entity.direction = -1
		end
		entity:SetTexture( textures[ t ][ "7" ].. tostring( entity.blinking ) )
		if ( entity.blinking == 1 ) and ( entity.direction == -1 ) then
			entity.blinking = nil
		end
	else
		-- Add a little to eyeID. Eventually it will, using floor(eyeID), jump to the next texture in the sequence
		-- eyeID moves up to 24 in eyeSpeed increments then drops down to 17 in eyeSpeed increments then ...
		-- At setup, a range if eyeSpeed values are used so no eye moves the same as another!
		entity.eyeID = entity.eyeID + entity.eyeSpeed
		if ( entity.eyeID >= 25 ) or ( entity.eyeID < 17 ) then
			-- Time to change direction
			entity.eyeSpeed = entity.eyeSpeed * -1
			entity.eyeID = entity.eyeID + entity.eyeSpeed
		end
		entity:SetTexture( textures[ t ][ "7" ].. tostring( floor( entity.eyeID ) ) )
	end
end

local function ShowOnMiniMap()

	if not Minimap:IsShown() then return end
	if ( mini.firstTimeShowing == true ) then AssignMiniMapPins() end
	
	-- Identify the current map and obtain player's (X,Y)

	mini.mapAreaInID = GetBestMapForUnit( "player" ) or 0
	mini.mapAreaInIDStr = tostring( mini.mapAreaInID )
	if GetPlayerMapPosition( mini.mapAreaInID, "player" ) then
		mini.xPlayer, mini.yPlayer = GetPlayerMapPosition( mini.mapAreaInID, "player" ):GetXY()
	end

	-- Hide decisions
	
	if not mini.validMapIDs[ mini.mapAreaInIDStr ] then
		if mini.wasInCorrectZone then
			for i = 1, tips[ mini.wasInCorrectZone ].num do
				mini[ mini.wasInCorrectZone ][ i ]:ClearAllPoints( 0 )
				mini[ mini.wasInCorrectZone ][ i ]:SetAlpha( 0 )
			end
			mini.wasInCorrectZone = nil
		end
		return
	end
	
	if mini.wasInCorrectZone then
		for k, v in pairs( tips ) do
			if ( k == mini.wasInCorrectZone ) then
				for i = 1, v.num do
					mini[ k ][ i ]:ClearAllPoints( 0 )
					mini[ k ][ i ]:SetAlpha( 0 )
				end
			end
		end
	end
	
	if ( AdorableHatchlingNestsDB.hidePins == "y" ) then 
		mini.wasInCorrectZone = nil
		return
	end
		
	mini.wasInCorrectZone = mini.validMapIDs[ mini.mapAreaInIDStr ]
	if ( mini.wasInCorrectZone == "S" ) and ( mini.insideCaveRR == true ) then
		mini.wasInCorrectZone = "W"
	end
	
	mini.xPlayer, mini.yPlayer = ( mini.xPlayer or 0 ) * 100, ( mini.yPlayer or 0 ) * 100
	if ( mini.xPlayer == 0 ) and ( mini.yPlayer == 0 ) then
		return
	end

	-- Show decisions

	mini.zoom = Minimap:GetZoom()
	mini.width, mini.height = Minimap:GetWidth(), Minimap:GetHeight()

	if ( AdorableHatchlingNestsDB.hidePins == "n" ) then
		for i = 1, tips[ mini.wasInCorrectZone ].num do
			mini[ mini.wasInCorrectZone ][ i ]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 
									mini[ mini.wasInCorrectZone ][ i ].x, mini[ mini.wasInCorrectZone ][ i ].y, mini.wasInCorrectZone ) )
			MinimapEyeMovements( mini[ mini.wasInCorrectZone ][ i ], i, mini.wasInCorrectZone )
			mini[ mini.wasInCorrectZone ][ i ]:SetAlpha( 1 )
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		World Map Setup
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- wasInCorrectZone has been repurposed as per the Minimap

local worldMap = { applyToAll = false, width = 0, height = 0, firstTimeShowing = true, wasInCorrectZone = nil,
					mapAreaLookID = 0, mapAreaLookIDStr = "", mapAreaLookOldID = 0 }

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		World Map Tooltips
--		==================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function WorldMapTooltipOnEnter( self )

	WorldMapTooltip:SetOwner( self, "ANCHOR_CURSOR" )
	WorldMapTooltip:SetText( "\124cFFBF00FF".. tips[ self.k ].tipTitle )
	WorldMapTooltip:AddLine( pc_colour_Prefix.. tips[ self.k ].tipLine1 )
	if self.tooltip then
		WorldMapTooltip:AddLine( self.tooltip )
	end
	if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
		WorldMapTooltip:AddLine( "(".. format( "%.02f", self.x ).. ",".. format( "%.02f", self.y ).. ")" )
	end
	
	WorldMapTooltip:Show()
	
	if IsControlKeyDown() then
		local frame = EnumerateFrames()
		local activeChatFrameEditBox;
		while frame do
			if frame:IsVisible() then
				local name = frame:GetName()
				if name and find( name, "ChatFrame(%d+)EditBox" ) then
					activeChatFrameEditBox = frame
					break
				end
			end
			frame = EnumerateFrames( frame )
		end
		if activeChatFrameEditBox then				
			local found = false
			for k, v in pairs( tips ) do
				if find( activeChatFrameEditBox:GetText(), tips[ k ].tipTitle ) then
					found = true
					break
				end
			end
			if not found then
				local _, eggLink = GetItemInfo( tips[ self.k ].eggID )
				if eggLink and ( self.k ~= "S" ) then
					activeChatFrameEditBox:Insert( eggLink.. " @ (".. format( "%.02f", self.x ).. ",".. 
													format( "%.02f", self.y ).. ") ".. " \"".. gsub( self.tooltip, "\n", " " ).. "\"" )
				else
					activeChatFrameEditBox:Insert( tips[ self.k ].tipTitle.. " @ (".. format( "%.02f", self.x ).. ",".. 
													format( "%.02f", self.y ).. ") ".. " \"".. gsub( self.tooltip, "\n", " " ).. "\"" )
				end
			end
		end
	end
end

local function WorldMapTooltipOnLeave( self )
	WorldMapTooltip:Hide()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Change Pins on the World Map			(and copy over to the Minimap)
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function ApplyPinSelection( arg0, typeIndex, tID )

	local t = ( typeIndex.type == "S" ) and "S" or "E"
	
	if ( worldMap.applyToAll == true ) then
		for k, v in pairs( tips ) do
			if ( ( t == "S" ) and ( k == "S" ) ) or ( ( t ~= "S" ) and ( k ~= "S" ) ) then
				AdorableHatchlingNestsDB[ "texture".. k ] = tID
				AdorableHatchlingNestsDB[ "saved".. k ] = {}
				for i = 1, v.num do
					worldMap[ k ][ i ].pinTexture:SetTexture( textures[ t ][ tID ] )
					worldMap[ k ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
					worldMap[ k ][ i ].pinTexture:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
															AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
					worldMap[ k ][ i ]:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
												AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
					mini[ k ][ i ]:SetTexture( textures[ t ][ tID ] )
					mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
					mini[ k ][ i ]:SetSize( 0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
											0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
				end
			end
		end
	else
		local i = tonumber( typeIndex.index )
		AdorableHatchlingNestsDB[ "saved".. typeIndex.type ][ typeIndex.index ] = tID
		worldMap[ typeIndex.type ][ i ].pinTexture:SetTexture( textures[ t ][ tID ] )
		worldMap[ typeIndex.type ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
		worldMap[ typeIndex.type ][ i ].pinTexture:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
															AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
		worldMap[ typeIndex.type ][ i ]:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
												AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
		mini[ typeIndex.type ][ i ]:SetTexture( textures[ t ][ tID ] )
		mini[ typeIndex.type ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
		mini[ typeIndex.type ][ i ]:SetSize( 0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
											0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
	end
end

local function ToggleApplyToAll()
	worldMap.applyToAll = not worldMap.applyToAll
end

local function ScalingStuffCopiedFromBlizzCode()

	-- Copied from UIDropDownMenu.lua

	local uiScale
	local uiParentScale = UIParent:GetScale()
	if ( GetCVar( "useUIScale" ) == "1" ) then
		uiScale = tonumber( GetCVar( "uiscale" ) )
		if ( uiParentScale < uiScale ) then
			uiScale = uiParentScale
		end
	else
		uiScale = uiParentScale
	end
	local cursorX, cursorY = GetCursorPosition()
	cursorX = cursorX / uiScale
	cursorY =  cursorY / uiScale
	local listFrame = _G[ "DropDownList1" ]
	listFrame:SetScale( uiScale )
	listFrame:ClearAllPoints()
	listFrame:SetPoint( "TOPLEFT", nil, "BOTTOMLEFT", cursorX, cursorY)
	listFrame:Show()
	listFrame.showTimer = UIDROPDOWNMENU_SHOW_TIME
	listFrame.isCounting = 1
end

local function WorldMapTextureSelection( typeIndex )

	local t = ( typeIndex.type == "S" ) and "S" or "E"
	worldMap.applyToAll = false
	local currentTexture = AdorableHatchlingNestsDB[ "saved".. typeIndex.type ][ typeIndex.index ] or 
							AdorableHatchlingNestsDB[ "texture".. typeIndex.type ]	
	local info = _G[ "DropDownList1" ]
	if info then
		UIDropDownMenu_InitializeHelper( info )
	end	
	info = UIDropDownMenu_CreateInfo()
	info.isTitle = true
	info.text = tips[ typeIndex.type ].tipTitle
	info.notCheckable = true
	info.isNotRadio = true
	UIDropDownMenu_AddButton( info )
	info.isTitle = nil
	info.disabled = nil		
	info.notCheckable = nil
	info.keepShownOnClick = true
	info.checked = worldMap.applyToAll
	info.text = L[ "Apply to |cFFBF00FFall|r pins" ]
	info.func = ToggleApplyToAll
	UIDropDownMenu_AddButton( info )
	info.notCheckable = true
	info.text = nil
	UIDropDownMenu_AddButton( info )
	info.notCheckable = nil
	info.keepShownOnClick = nil
	info.func = ApplyPinSelection	
	info.arg1 = typeIndex
	for i = 1, textures[ t ].num do
		info.arg2 = tostring( i )
		info.checked = currentTexture == info.arg2
		info.text = textures[ t ].name[ info.arg2 ]
		info.icon = ( ( i == 7 ) and ( t == "E" ) ) and textures[ t ][ "7" ].."19" or textures[ t ][ info.arg2 ]
		-- Blizzard's UIDropDownMenu.lua does not allow me to adjust the size of the icon, therefore icons will appear as different sizes :(
		info.tCoordLeft = textures[ t ].coords[ info.arg2 ][ 1 ]
		info.tCoordRight = textures[ t ].coords[ info.arg2 ][ 2 ]
		info.tCoordTop = textures[ t ].coords[ info.arg2 ][ 3 ]
		info.tCoordBottom = textures[ t ].coords[ info.arg2 ][ 4 ]
		UIDropDownMenu_AddButton( info )
	end
	
	ScalingStuffCopiedFromBlizzCode()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Assign Pins to the World Map
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function AdjustWorldMapCoordinates( x, y )
	return ( x - 50 ) * worldMap.width / 100, ( worldMap.height / 2 ) - ( worldMap.height * y / 100 )
end

local function NewlyShowingWorldMapZone()		-- Assign the clickable buttons and textures to the correct location on the World Map

	worldMap.mapAreaLookOldID = worldMap.mapAreaLookID
	if not mini.validMapIDs[ worldMap.mapAreaLookIDStr ] then return end

	worldMap.width = WorldMapFrame.ScrollContainer and WorldMapFrame.ScrollContainer.Child:GetWidth() or WorldMapDetailFrame:GetWidth()
	worldMap.height = WorldMapFrame.ScrollContainer and WorldMapFrame.ScrollContainer.Child:GetHeight() or WorldMapDetailFrame:GetHeight()
	
	for k, v in pairs( tips ) do
		for i = 1, v.num do
			local x, y = AdjustWorldMapCoordinates( v[ tostring(i) ].x, v[ tostring(i) ].y )
			worldMap[ k ][ i ].pinTexture:ClearAllPoints()
			worldMap[ k ][ i ].pinTexture:SetPoint( "CENTER", WorldMapFrame.ScrollContainer.Child, "CENTER", x, y )
			worldMap[ k ][ i ]:ClearAllPoints()
			worldMap[ k ][ i ]:SetPoint( "CENTER", WorldMapFrame.ScrollContainer.Child, "CENTER", x, y )
		end
	end
end

local function AssignWorldMapPins()

	local function CreateWorldMapPin( typeIndex )
		local pin = CreateFrame( "Button", "AHN".. lower( typeIndex.type ).. typeIndex.index, WorldMapFrame.ScrollContainer.Child, 
									UIDropDownMenuTemplate )
		pin.eyeID = random( 8 ) + 16
		pin.eyeSpeed = 0.05 * random( 6 ) + 0.1
		pin.tooltip = tips[ typeIndex.type ][ typeIndex.index ].tip
		pin.x = tips[ typeIndex.type ][ typeIndex.index ].x
		pin.y = tips[ typeIndex.type ][ typeIndex.index ].y
		pin.k = typeIndex.type
		local t = ( typeIndex.type == "S" ) and "S" or "E"
		pin:HookScript( "OnEnter", WorldMapTooltipOnEnter )
		pin:HookScript( "OnLeave", WorldMapTooltipOnLeave )
		pin:HookScript( "OnClick", function( self, button ) WorldMapTextureSelection( typeIndex ) end )
		local textureID = AdorableHatchlingNestsDB[ "saved".. typeIndex.type ][ typeIndex.index ]
							or AdorableHatchlingNestsDB[ "texture".. typeIndex.type ]
		local pinTexture = pin:CreateTexture( nil, "OVERLAY" )
		pinTexture:SetTexture( ( textureID == "7" ) and textures[ t ][ "7" ].. floor( tostring( pin.eyeID ) ) 
													or textures[ t ][ textureID ] )
		pin:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ textureID ], 
						AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ textureID ] )
		pinTexture:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ textureID ], 
						AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ textureID ] )
		pin.pinTexture = pinTexture
		pin:SetFrameStrata( "HIGH" )
		pin:Hide()
		return pin
	end

	for k, v in pairs( tips ) do
		worldMap[ k ] = {}
		for i = 1, v.num do
			worldMap[ k ][ i ] = CreateWorldMapPin( { type = k, index = tostring( i ) } )
		end
	end
	
	worldMap.firstTimeShowing = false
	NewlyShowingWorldMapZone()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Show on the World Map
--		=====================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function EyeMovementsWorldMap( entity, i , pinType )

	-- WoW has several "raptor eye" textures named "Interface\\LFGFrame\\BattlenetWorking"..nn
	-- When you are queued for an instance, WoW presents these textures in a cycle, resulting in a moving eye animation
	-- This AddOn also cycles through some of these textures. For variety, I vary the speed of eye movement and randomise a blinking effect
	-- Every possible pin will have an entity.eyeID (range 17 to 24) and entity.eyeSpeed (range  0.15 to 0.4)

	local textureID = AdorableHatchlingNestsDB[ "saved".. pinType ][ tostring( i ) ] or AdorableHatchlingNestsDB[ "texture".. pinType ]
	if ( textureID ~= "7" ) then return end
	
	local t = ( pinType == "S" ) and "S" or "E"

	-- eyeID constantly changes. When exactly "19" blinking will randomly be triggered if not already blinking
	if floor( entity.eyeID ) == 19 then
		if ( entity.blinking == nil ) then
			if ( random( 60 ) >= 55 ) then	-- 10% of the time
				entity.blinking = 0			-- This holds the blinking textureID 1->2->3->4->4->3->2->1
				entity.direction = 1
			end
		end
	end
	if entity.blinking then
		entity.blinking = entity.blinking + entity.direction
		if ( entity.blinking > 4 ) then
			entity.blinking = 4
			entity.direction = -1
		end
		entity.pinTexture:SetTexture( textures[ t ][ "7" ].. tostring( entity.blinking ) )
		if (entity.blinking == 1 ) and ( entity.direction == -1 ) then
			entity.blinking = nil
		end
	else
		-- eyeID moves up to 24 in eyeSpeed increments then drops down to 17 in eyeSpeed increments then ...
		entity.eyeID = entity.eyeID + entity.eyeSpeed
		if ( entity.eyeID >= 25 ) or ( entity.eyeID < 17 ) then
			entity.eyeSpeed = entity.eyeSpeed * -1
			entity.eyeID = entity.eyeID + entity.eyeSpeed
		end
		entity.pinTexture:SetTexture( textures[ t ][ "7" ].. tostring( floor( entity.eyeID ) ) )
	end
end

local function ShowOnWorldMap()

	-- From OnUpdate cycle. All decision making logic re show/hide goes in this block

	if not WorldMapFrame:IsShown() then return end			
	if ( worldMap.firstTimeShowing == true ) then 
		AssignWorldMapPins()
	end
	worldMap.mapAreaLookID = WorldMapFrame:GetMapID() or 0
	worldMap.mapAreaLookIDStr = tostring( worldMap.mapAreaLookID )
	if ( worldMap.mapAreaLookID ~= worldMap.mapAreaLookOldID ) then
		NewlyShowingWorldMapZone()
		if mini.validMapIDs[ worldMap.mapAreaLookIDStr ] then
			PlayRandomSound()
		end
	end
	
	-- Hide decisions
	
	if not mini.validMapIDs[ worldMap.mapAreaLookIDStr ] then
		if worldMap.wasInCorrectZone then
			for k, v in pairs( tips ) do
				if worldMap[ k ][ 1 ]:IsVisible() then
					for i = 1, v.num do
						worldMap[ k ][ i ]:Hide()
					end
				end
			end
			worldMap.wasInCorrectZone = nil
		end
		return
	end

	-- In my LFH AddOn I show cave entrances when outside caves and items in the caves are never shown on the World Map.
	-- In this AddOn I decided to place the nest on the World Map when inside. This is because of the very useful navigation hints
	local currentK = ( ( worldMap.mapAreaLookID == 56 ) and ( mini.insideCaveRR == true ) ) 
							and "W" 
							or mini.validMapIDs[ worldMap.mapAreaLookIDStr ]

	if worldMap.wasInCorrectZone and ( worldMap.wasInCorrectZone ~= currentK ) then
		for k, v in pairs( tips ) do
			if ( k == worldMap.wasInCorrectZone ) then
				for i = 1, v.num do
					worldMap[ k ][ i ]:Hide()
				end
			end
		end
	end
	
	if ( AdorableHatchlingNestsDB.hidePins == "y" ) then 
		worldMap.wasInCorrectZone = nil
		return
	end

	worldMap.wasInCorrectZone = currentK
	
	-- Show decisions
	
	if ( AdorableHatchlingNestsDB.hidePins == "n" ) then
		for i = 1, tips[ worldMap.wasInCorrectZone ].num do
			EyeMovementsWorldMap( worldMap[ worldMap.wasInCorrectZone ][ i ], i, worldMap.wasInCorrectZone )
			worldMap[ worldMap.wasInCorrectZone ][ i ]:Show()
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		World Map's "Magnifying Glass" Drop Down Menu Options
--		=====================================================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function TogglePins()
	AdorableHatchlingNestsDB.hidePins = ( AdorableHatchlingNestsDB.hidePins == "y" ) and "n" or "y"
	if mini.validMapIDs[ worldMap.mapAreaLookIDStr ] then
		ShowOnWorldMap()
	end
end
local function ToggleCoordinates()
	AdorableHatchlingNestsDB.showCoordinates = ( AdorableHatchlingNestsDB.showCoordinates == "y" ) and "n" or "y"
end
local function ToggleRaptorSounds()
	AdorableHatchlingNestsDB.raptorSounds = ( AdorableHatchlingNestsDB.raptorSounds == "y" ) and "n" or "y"
end

local function ResetPins()

	for k, v in pairs( tips ) do
		local t = ( k == "S" ) and "S" or "E"
		local tID = AdorableHatchlingNestsDB[ "texture".. k ]
		AdorableHatchlingNestsDB[ "saved".. k ] = {}
		for i = 1, v.num do
			worldMap[ k ][ i ].pinTexture:SetTexture( ( tID == "7" ) 
														and textures[ t ][ "7" ].. tostring( floor( worldMap[ k ][ i ].eyeID ) ) 
														or textures[ t ][ tID ] )
			worldMap[ k ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ tID ] ) )
			mini[ k ][ i ]:SetTexture( ( tID == "7" )
													and textures[ t ][ "7" ].. tostring( floor( mini[ k ][ i ].eyeID ) )
													or textures[ t ][ tID ] )
			mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ tID ] ) )
			worldMap[ k ][ i ].pinTexture:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
													AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
			worldMap[ k ][ i ]:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
										AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
			mini[ k ][ i ]:SetSize( 0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
									0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
		end
	end
	
	ShowOnWorldMap()
end

local function GoToDustwallowMarsh( info )
	WorldMapFrame:SetMapID( mini.dustwallowMarshID )
end
local function GoToNorthernBarrens( info )
	WorldMapFrame:SetMapID( mini.northernBarrensID )
end
local function GoToUnGroCrater( info )
	WorldMapFrame:SetMapID( mini.unGoroCraterID )
end
local function GoToWetlands( info )
	WorldMapFrame:SetMapID( mini.wetlandsID )
end

local function AddMagnifyingGlassOptions()

	local info = UIDropDownMenu_CreateInfo()
	UIDropDownMenu_AddSeparator( 1 )
	info.isTitle = true
	info.text = addonTitle
	info.notCheckable = true
	info.isNotRadio = true
	UIDropDownMenu_AddButton( info, 1 )
	info.isTitle = nil
	info.disabled = nil		
	info.text = L[ "Pins" ]
	info.func = TogglePins
	info.notCheckable = nil
	info.keepShownOnClick = true
	info.checked = AdorableHatchlingNestsDB.hidePins == "n"
	info.tooltipTitle = L[ "Pins" ]
	info.tooltipText = L[ "Show |cFFBF00FFpins|r on both the World Map and the Minimap" ]
	info.tooltipOnButton = true
	UIDropDownMenu_AddButton( info, 1 )	
	info.text = L[ "Show Coordinates" ]
	info.func = ToggleCoordinates
	info.checked = AdorableHatchlingNestsDB.showCoordinates == "y"
	info.tooltipTitle = L[ "Show Coordinates" ]
	info.tooltipText = L[ "Show |cFFBF00FFcoordinates|r in tooltips for both the World Map and the Minimap" ]
	info.tooltipOnButton = true
	UIDropDownMenu_AddButton( info, 1 )
	info.text = L[ "Raptor Sounds" ]
	info.func = ToggleRaptorSounds
	info.checked = AdorableHatchlingNestsDB.raptorSounds == "y"
	info.tooltipTitle = L[ "Raptor Sounds" ]
	info.tooltipText = L[ "Play |cFFBF00FFraptor sounds|r when mousing over pins and opening the World Map" ]
	info.tooltipOnButton = true
	UIDropDownMenu_AddButton( info, 1 )
	info.tooltipTitle = nil
	info.tooltipText = nil
	info.notCheckable = true	
	if mini.validMapIDs[ worldMap.mapAreaLookIDStr ] then
		info.text = L[ "Reset Pins" ]
		info.func = ResetPins
		info.tooltipTitle = L[ "Reset Pins" ]
		info.tooltipText = L[ "Will be applied to both the World Map and the Minimap.\n"..
							"This effectively erases any changes you made to individual pins" ]
		info.tooltipOnButton = true
		UIDropDownMenu_AddButton( info, 1 )
	end
	info.tooltipTitle = nil
	info.tooltipText = nil
	info.keepShownOnClick = nil
	if ( worldMap.mapAreaLookID ~= mini.dustwallowMarshID ) then
		info.text = L[ "Go to Dustwallow Marsh" ]
		info.func = GoToDustwallowMarsh
		UIDropDownMenu_AddButton( info, 1 )
	end
	if ( worldMap.mapAreaLookID ~= mini.northernBarrensID ) then
		info.text = L[ "Go to Northern Barrens" ]
		info.func = GoToNorthernBarrens
		UIDropDownMenu_AddButton( info, 1 )
	end
	if ( worldMap.mapAreaLookID ~= mini.unGoroCraterID ) then
		info.text = L[ "Go to Un'Goro Crater" ]
		info.func = GoToUnGroCrater
		UIDropDownMenu_AddButton( info, 1 )
	end
	if ( worldMap.mapAreaLookID ~= mini.wetlandsID ) then
		info.text = L[ "Go to Wetlands" ]
		info.func = GoToWetlands
		UIDropDownMenu_AddButton( info, 1 )
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		OnEvent Handler
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local eventFrame = CreateFrame( "Frame" )

local function OnEventHandler( self, event, arg1, ...)

	if event == "ADDON_LOADED" then
	
		if arg1 ~= addonName then return end

		if not AdorableHatchlingNestsDB then AdorableHatchlingNestsDB = {} end		
		local pinSize = AdorableHatchlingNestsDB.pinSize or 25				-- Btw - 19 is the game's default mineral node size
		local savedD = AdorableHatchlingNestsDB.savedD or {}
		local savedN = AdorableHatchlingNestsDB.savedN or {}
		local savedU = AdorableHatchlingNestsDB.savedU or {}
		local savedS = AdorableHatchlingNestsDB.savedS or {}
		local savedW = AdorableHatchlingNestsDB.savedW or {}
		local textureD = AdorableHatchlingNestsDB.textureD or "7"
		local textureN = AdorableHatchlingNestsDB.textureN or "7"
		local textureU = AdorableHatchlingNestsDB.textureU or "7"
		local textureS = AdorableHatchlingNestsDB.textureS or "1"
		local textureW = AdorableHatchlingNestsDB.textureW or "1"
		local hidePins = AdorableHatchlingNestsDB.hidePins or "n"
		local showCoordinates = AdorableHatchlingNestsDB.showCoordinates or "y"
		local alwaysAprilFool = AdorableHatchlingNestsDB.alwaysAprilFool or "n"
		local raptorSounds = AdorableHatchlingNestsDB.raptorSounds or "y"
		AdorableHatchlingNestsDB = {}
		AdorableHatchlingNestsDB.pinSize = pinSize
		AdorableHatchlingNestsDB.savedD = savedD
		AdorableHatchlingNestsDB.savedN = savedN
		AdorableHatchlingNestsDB.savedU = savedU
		AdorableHatchlingNestsDB.savedS = savedS
		AdorableHatchlingNestsDB.savedW = savedW
		AdorableHatchlingNestsDB.textureD = textureD
		AdorableHatchlingNestsDB.textureN = textureN
		AdorableHatchlingNestsDB.textureU = textureU
		AdorableHatchlingNestsDB.textureS = textureS
		AdorableHatchlingNestsDB.textureW = textureW
		AdorableHatchlingNestsDB.hidePins = hidePins
		AdorableHatchlingNestsDB.showCoordinates = showCoordinates
		AdorableHatchlingNestsDB.alwaysAprilFool = alwaysAprilFool
		AdorableHatchlingNestsDB.raptorSounds = raptorSounds
		
		eventFrame:UnregisterEvent( "ADDON_LOADED" )
		
		if locale == "deDE" then
			addonTitle = GetAddOnMetadata( addonName, "Title-deDE" )
		elseif locale == "esES" or locale == "esMX" then
			addonTitle = GetAddOnMetadata( addonName, "Title-esES" )
		elseif locale == "frFR" then
			addonTitle = GetAddOnMetadata( addonName, "Title-frFR" )
		elseif locale == "itIT" then
			addonTitle = GetAddOnMetadata( addonName, "Title-itIT" )
		elseif locale == "koKR" then
			addonTitle = GetAddOnMetadata( addonName, "Title-koKR" )
		elseif locale == "ptBR" then
			addonTitle = GetAddOnMetadata( addonName, "Title-ptBR" )
		elseif locale == "ruRU" then
			addonTitle = GetAddOnMetadata( addonName, "Title-ruRU" )
		elseif locale == "zhCN" then
			addonTitle = GetAddOnMetadata( addonName, "Title-zhCN" )
		elseif locale == "zhTW" then
			addonTitle = GetAddOnMetadata( addonName, "Title-zhTW" )
		else
			addonTitle = GetAddOnMetadata( addonName, "Title" )
		end
	
	elseif event == "PLAYER_ENTERING_WORLD" then
	
		for _, overlayFrame in next, WorldMapFrame.overlayFrames do
			if overlayFrame.Border and ( overlayFrame.Border:GetTexture() == "Interface\\Minimap\\MiniMap-TrackingBorder" )  then
				hooksecurefunc( overlayFrame, "InitializeDropDown", AddMagnifyingGlassOptions )
				break
			end
		end
		
		eventFrame:UnregisterEvent( "PLAYER_ENTERING_WORLD" )
	end
end

eventFrame:RegisterEvent( "ADDON_LOADED" )
eventFrame:RegisterEvent( "PLAYER_ENTERING_WORLD" )
eventFrame:SetScript( "OnEvent", OnEventHandler )

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		OnUpdate Handler
--		================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local timeSinceLastUpdate = 0

local function OnUpdateHandler()

	-- From a certain patch/update the timeElapsed was passed as a value. But this block should work across all versions of WoW.
	-- Actually timeElapsed ignores the time elapsed while looking at a loading screen or a cinematic. GetTime is better

	local curTime = GetTime()
	if curTime - timeSinceLastUpdate <= 0.05 then return end
	timeSinceLastUpdate = curTime

	mini.isIndoors = IsIndoors()
	
	if ( GetSubZoneText() == L[ "Raptor Ridge" ] ) and mini.isIndoors then
		mini.insideCaveRR = true
	else
		mini.insideCaveRR = false
	end

	ShowOnMiniMap()		
	ShowOnWorldMap()
	
	if not mini.validMapIDs[ mini.mapAreaInIDStr ] then return end

	local t, mouseOver, scale, cursorX, cursorY, pixels, hypotenuse = "", false;
	
	for k, v in pairs( tips ) do
		t = ( k == "S" ) and "S" or "E"
		for i = 1, v.num do
		
			if ( mini[ k ][ i ]:IsMouseOver( 0,0,0,0 ) == true ) and ( mini[ k ][ i ]:GetAlpha() == 1 ) then
			
				if ( mini.tooltipShowing == false ) then
					PlayRandomSound()
				end
				
				mouseOver, mini.tooltipShowing = true, true
			
				GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
				GameTooltip:SetText( "\124cFFBF00FF".. tips[ k ].tipTitle )
				GameTooltip:AddLine( pc_colour_Prefix.. tips[ k ].tipLine1 )
				GameTooltip:AddLine( mini[ k ][ i ].tooltip )
				if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
					GameTooltip:AddLine( "(".. format( "%.02f", mini[ k ][ i ].x ).. ",".. format( "%.02f", mini[ k ][ i ].y ).. ")" )
				end
				GameTooltip:Show()
				
				if ( mini.leftMouseUp == true ) then
					if ( worldMap.firstTimeShowing == true ) then
						AssignWorldMapPins()
					end
					local curTexture = tonumber( AdorableHatchlingNestsDB[ "saved".. k ][ tostring( i ) ] or AdorableHatchlingNestsDB[ "texture".. k ] )
					if ( IsShiftKeyDown() == true ) then
						curTexture = ( curTexture <= 1 ) and textures[ t ].num or ( curTexture - 1 )
					else
						curTexture = ( curTexture >= textures[ t ].num ) and 1 or ( curTexture + 1 )
					end
					curTexture = tostring( curTexture )
					AdorableHatchlingNestsDB[ "saved".. k ][ tostring( i ) ] = curTexture
					mini[ k ][ i ]:SetTexture( ( curTexture == "7" )
															and textures[ t ][ curTexture ].. tostring( floor( mini[ k ][ i ].eyeID ) )
															or textures[ t ][ curTexture ] )					
					mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ curTexture ] ) )					
					worldMap[ k ][ i ].pinTexture:SetTexture( ( curTexture == "7" )
															and textures[ t ][ curTexture ].. tostring( floor( mini[ k ][ i ].eyeID ) )
															or textures[ t ][ curTexture ] )					
					worldMap[ k ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ curTexture ] )  )
					
					mini[ k ][ i ]:SetSize( 0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ curTexture ],
											0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ curTexture ] )
					worldMap[ k ][ i ].pinTexture:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ curTexture ],
															AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ curTexture ] )
					worldMap[ k ][ i ]:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ curTexture ],
												AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ curTexture ] )
				elseif IsControlKeyDown() then
					local frame = EnumerateFrames()
					local activeChatFrameEditBox;
					while frame do
						if frame:IsVisible() then
							local name = frame:GetName()
							if name and find( name, "ChatFrame(%d+)EditBox" ) then
								activeChatFrameEditBox = frame
								break
							end
						end
						frame = EnumerateFrames( frame )
					end
					if activeChatFrameEditBox then
						local found = false
						for k, v in pairs( tips ) do
							if find( activeChatFrameEditBox:GetText(), tips[ k ].tipTitle ) then
								found = true
								break
							end
						end
						if not found then
							local _, eggLink = GetItemInfo( tips[ k ].eggID )
							if eggLink and ( k ~= "S" ) then
								activeChatFrameEditBox:Insert( eggLink.. " @ (".. format( "%.02f", mini[ k ][ i ].x ).. ",".. 
																format( "%.02f", mini[ k ][ i ].y ).. ") ".. " \"".. 
																gsub( mini[ k ][ i ].tooltip, "\n", " " ).. "\"" )
							else
								activeChatFrameEditBox:Insert( tips[ k ].tipTitle.. " @ (".. format( "%.02f", mini[ k ][ i ].x ).. ",".. 
																format( "%.02f", mini[ k ][ i ].y ).. ") ".. " \"".. 
																gsub( mini[ k ][ i ].tooltip, "\n", " " ).. "\"" )
							end
						end
					end
				end
				break
			end
		end
		if ( mouseOver == true ) then break end
	end
	if ( mouseOver == false ) and ( mini.tooltipShowing == true ) then
		GameTooltip:Hide()
		mini.tooltipShowing = false
	end
	mini.leftMouseUp = false
end

eventFrame:SetScript( "OnUpdate", OnUpdateHandler )

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Slash Commands
--		==============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local soundHandle;

SLASH_AdorableHN1, SLASH_AdorableHN2, SLASH_AdorableHN3, SLASH_AdorableHN4, SLASH_AdorableHN5 = "/ahn", "/ador", "/raptor", "/rapt", "/arn"

SlashCmdList[ "AdorableHN" ] = function( options )

	local options1, secondParm;
	for v in gmatch( options, "(%S+)" ) do
		v = lower( v )
		if not options1 then
			options1 = sub( v,1,1 )
		else
			secondParm = sub( v,1,2 )
			break
		end
	end

	if not options1 or ( options1 == "?" ) then
		printPC( pc_colour_Highlight.. L[ "Commands" ].. ":\n"..
			pc_colour_Highlight.. "s n".. pc_colour_PlainText.. " = ".. L[ "Pin size" ].. ". ".. L[ "10 to 50" ] )
			
	elseif ( options1 == "e" ) then
		TogglePins()

	elseif ( options1 == "c" ) then
		ToggleCoordinates()

	elseif ( options1 == "r" ) then
		ResetPins()

	elseif ( options1 == "s" ) then
		local parm = tonumber( secondParm )
		local changed = false
		if parm then
			if ( parm >= 10 ) and ( parm <= 50 ) then
				local oldValue = AdorableHatchlingNestsDB.pinSize
				AdorableHatchlingNestsDB.pinSize = parm
				if ( worldMap.firstTimeShowing == true ) then
					AssignWorldMapPins()
				end
				for k, v in pairs( tips ) do
					local t = ( k == "S" ) and "S" or "E"
					for i = 1, v.num do
						local tID = AdorableHatchlingNestsDB[ "saved".. k ][ tostring( i ) ] or AdorableHatchlingNestsDB[ "texture".. k ]
						worldMap[ k ][ i ].pinTexture:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
																AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
						worldMap[ k ][ i ]:SetSize( AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
													AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
						mini[ k ][ i ]:SetSize( 0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ],
												0.7 * AdorableHatchlingNestsDB.pinSize * textures[ t ].size[ tID ] )
					end
				end
				if ( oldValue ~= parm ) then changed = true end
			end
		end
		printPC( pc_colour_Highlight.. "s".. pc_colour_PlainText.. " = ".. pc_colour_Highlight.. AdorableHatchlingNestsDB.pinSize )
		if ( changed == false ) then
			printPC( "(".. L[ "Default" ].. " = 25)" )
			SlashCmdList[ "AdorableHN" ]("")
		end

	-- Easter Eggs. Enjoy!

	elseif ( options1 == "p" ) then
		PlayRandomSound()

	elseif ( options1 == "a" ) then
		AdorableHatchlingNestsDB.alwaysAprilFool = ( AdorableHatchlingNestsDB.alwaysAprilFool == "y" ) and "n" or "y"

	elseif ( options1 == "g" ) then
		PlaySoundFile( "Interface\\AddOns\\AdorableHatchlingNests\\Godzilla.mp3" )

	elseif ( options1 == "t" ) then
		PlaySoundFile( "Interface\\AddOns\\AdorableHatchlingNests\\TyrannosaurusRex1.mp3" )

	elseif ( options1 == "v" ) then
		PlaySoundFile( "Interface\\AddOns\\AdorableHatchlingNests\\Velociraptor".. tostring( random( 2 ) ).. ".mp3" )

	elseif ( options1 == "z" ) then
		if soundHandle then
			StopSound( soundHandle, 5000 )
			soundHandle = nil
		else
			local soundSelection = random( 3 )		
			_, soundHandle = PlaySound( ( soundSelection == 1 ) and 22161 or	-- Vashj'ir
										( soundSelection == 2 ) and 14893 or	-- Sholazar
										15087 )									-- Drak'Tharon Keep Raptor Pens
		end
	end
end